#!/bin/bash

CWD="@CMAKE_CURRENT_BINARY_DIR@"

TDIR=""
PID_MULTI_STREAM=0
PID_DAQD=0

function kill_proc {
    if [ $1 -gt 0 ]; then
        echo "Closing process $1"
        kill $1
    fi
}

function cleanup {
    rm -rf daqdrc_live_test_final
    if [ "x$TDIR" != "x" ]; then
        if [ -d $TDIR ]; then
            rm -rf "$TDIR"
        fi
    fi
    for name in local_dc; do
        if [ -e "/dev/shm/$name" ]; then
            rm -f "/dev/shm/$name"
        fi
    done
    kill_proc $PID_MULTI_STREAM
    kill_proc $PID_DAQD
}

MUTLI_STREAM="$CWD/../fe_stream_test/fe_simulation/fe_simulated_streams"
if [ ! -x "$MUTLI_STREAM" ]; then
    echo "cannot find $MULTI_STREAM"
    exit 1
fi

DAQD="$CWD/../daqd/daqd"
if [ ! -x "$DAQD" ]; then
    echo "cannot find $DAQD"
    exit 1
fi

FE_STREAM_CHECK_NDS="$CWD/../fe_stream_test/fe_stream_check_nds"
if [ ! -x "$FE_STREAM_CHECK_NDS" ]; then
  echo "cannot find $FE_STREAM_CHECK_NDS"
  exit 1
fi

if [ ! -r /dev/gpstime ]; then
  echo "the gpstime module must be loaded, configured, and accessible by this user"
  exit 1
fi

PYTHON=""
which python > /dev/null
if [ $? -eq 0 ]; then
    PYTHON=`which python`
else
    which python3 > /dev/null
    if [ $? -eq 0 ]; then
        PYTHON=`which python3`
    else
        echo "Cannot find python or python3"
        exit 1
    fi
fi

trap cleanup EXIT

TDIR=`$PYTHON -c "from __future__ import print_function; import tempfile; print(tempfile.mkdtemp())"`
mkdir "$TDIR/ini_files"
mkdir "$TDIR/logs"

echo "Ini dir = $TDIR/ini_files"

"$MUTLI_STREAM" -i "$TDIR/ini_files" -M "$TDIR/ini_files/master" -b local_dc -m 100 -k 300 -R 247 -s shm:// > "$TDIR/logs/multi_stream" &
PID_MULTI_STREAM=$!

echo "Streamer PID = PID_MULTI_STREAM"

sleep 1

MASTER_FILE="$TDIR/ini_files/master"
TESTPOINT_FILE=""
cat daqdrc_live_posix_shmem_test | sed s\|MASTER\|$MASTER_FILE\| | sed s\|TESTPOINT\|$TESTPOINT_FILE\| > daqdrc_live_posix_shmem_test_final
"$DAQD" -c daqdrc_live_posix_shmem_test_final &> "$TDIR/logs/daqd" &
PID_DAQD=$!

echo "Sleeping to allow the daq to start"
sleep 15

"$FE_STREAM_CHECK_NDS" -c 100 -t -2
RESULT_ABS=$?

echo "Testing return $RESULT_ABS (0 = success)"

"$FE_STREAM_CHECK_NDS" -c 1000
RESULT_STREAM=$?

echo "Testing return $RESULT_STREAM (0 = success)"

let RESULT=RESULT_ABS+RESULT_STREAM

echo "Final RESULT=$RESULT"

exit $RESULT
#echo "Press enter to continue..."
#DUMMY=""
#read DUMMY